/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 * Apache Antタスク [BlancoPleiadesUtilPleiades2Tmx]のクラス
 */
package blanco.pleiades.util.task;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

import blanco.pleiades.util.task.valueobject.BlancoPleiadesUtilPleiades2TmxProcessInput;

/**
 * Apache Antタスク [BlancoPleiadesUtilPleiades2Tmx]のクラス。
 *
 * [TMX対応ツール] Pleiades形式をLISA TMX形式に変換します。<br>
 * このクラスでは、Apache Antタスクで一般的に必要なチェックなどのコーディングを肩代わりします。
 * 実際の処理は パッケージ[blanco.pleiades.util.task]にBlancoPleiadesUtilPleiades2TmxBatchProcessクラスを作成して記述してください。<br>
 * <br>
 * Antタスクへの組み込み例<br>
 * <pre>
 * &lt;taskdef name=&quot;blancopleiadesutilpleiades2tmx&quot; classname=&quot;blanco.pleiades.util.task.BlancoPleiadesUtilPleiades2TmxTask">
 *     &lt;classpath&gt;
 *         &lt;fileset dir=&quot;lib&quot; includes=&quot;*.jar&quot; /&gt;
 *         &lt;fileset dir=&quot;lib.ant&quot; includes=&quot;*.jar&quot; /&gt;
 *     &lt;/classpath&gt;
 * &lt;/taskdef&gt;
 * </pre>
 */
public class BlancoPleiadesUtilPleiades2TmxTask extends Task {
    /**
     * [TMX対応ツール] Pleiades形式をLISA TMX形式に変換します。
     */
    protected BlancoPleiadesUtilPleiades2TmxProcessInput fInput = new BlancoPleiadesUtilPleiades2TmxProcessInput();

    /**
     * [TMX対応ツール] Pleiades形式をLISA TMX形式に変換します。
     */
    protected boolean fIsFieldSourcefileProcessed = false;

    /**
     * [TMX対応ツール] Pleiades形式をLISA TMX形式に変換します。
     */
    protected boolean fIsFieldTargetfileProcessed = false;

    /**
     * verboseモードで動作させるかどうか。
     *
     * @param arg verboseモードで動作させるかどうか。
     */
    public void setVerbose(final boolean arg) {
        fInput.setVerbose(arg);
    }

    /**
     * verboseモードで動作させるかどうか。
     *
     * @return verboseモードで動作させるかどうか。
     */
    public boolean getVerbose() {
        return fInput.getVerbose();
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力元となるPleiadesの translation.properties ファイル。<br>
     *
     * @param arg セットしたい値
     */
    public void setSourcefile(final String arg) {
        fInput.setSourcefile(arg);
        fIsFieldSourcefileProcessed = true;
    }

    /**
     * Antタスクの[sourcefile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 1<br>
     * 入力元となるPleiadesの translation.properties ファイル。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getSourcefile() {
        return fInput.getSourcefile();
    }

    /**
     * Antタスクの[targetfile]アトリビュートのセッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先となるTMXファイル。<br>
     *
     * @param arg セットしたい値
     */
    public void setTargetfile(final String arg) {
        fInput.setTargetfile(arg);
        fIsFieldTargetfileProcessed = true;
    }

    /**
     * Antタスクの[targetfile]アトリビュートのゲッターメソッド。
     *
     * 項目番号: 2<br>
     * 出力先となるTMXファイル。<br>
     * 必須アトリビュートです。Apache Antタスク上で必ず値が指定されます。<br>
     *
     * @return このフィールドの値
     */
    public String getTargetfile() {
        return fInput.getTargetfile();
    }

    /**
     * Antタスクのメイン処理。Apache Antから このメソッドが呼び出されます。
     *
     * @throws BuildException タスクとしての例外が発生した場合。
     */
    public final void execute() throws BuildException {
        System.out.println("BlancoPleiadesUtilPleiades2TmxTask begin.");

        // 項目番号[1]、アトリビュート[sourcefile]は必須入力です。入力チェックを行います。
        if (fIsFieldSourcefileProcessed == false) {
            throw new BuildException("必須アトリビュート[sourcefile]が設定されていません。処理を中断します。");
        }
        // 項目番号[2]、アトリビュート[targetfile]は必須入力です。入力チェックを行います。
        if (fIsFieldTargetfileProcessed == false) {
            throw new BuildException("必須アトリビュート[targetfile]が設定されていません。処理を中断します。");
        }

        if (getVerbose()) {
            System.out.println("- verbose:[true]");
            System.out.println("- sourcefile:[" + getSourcefile() + "]");
            System.out.println("- targetfile:[" + getTargetfile() + "]");
        }

        try {
            // 実際のAntタスクの主処理を実行します。
            // この箇所でコンパイルエラーが発生する場合、BlancoPleiadesUtilPleiades2TmxProcessインタフェースを実装して blanco.pleiades.util.taskパッケージに BlancoPleiadesUtilPleiades2TmxProcessImplクラスを作成することにより解決できる場合があります。
            final BlancoPleiadesUtilPleiades2TmxProcess proc = new BlancoPleiadesUtilPleiades2TmxProcessImpl();
            if (proc.execute(fInput) != BlancoPleiadesUtilPleiades2TmxBatchProcess.END_SUCCESS) {
                throw new BuildException("タスクは異常終了しました。");
            }
        } catch (IllegalArgumentException e) {
            if (getVerbose()) {
                e.printStackTrace();
            }
            throw new BuildException(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中に例外が発生しました。処理を中断します。" + e.toString());
        } catch (Error e) {
            e.printStackTrace();
            throw new BuildException("タスクを処理中にエラーが発生しました。処理を中断します。" + e.toString());
        }
    }
}
